#include "arduino_secrets.h"


#include <DFRobot_HuskyLens.h>
#include <HUSKYLENS.h>
#include <HUSKYLENSMindPlus.h>
#include <HuskyLensProtocolCore.h>
#include <SoftwareSerial.h>
/*
  Sketch generated by the Arduino IoT Cloud Thing "Untitled"
  https://create.arduino.cc/cloud/things/e7fc553b-4d3d-415e-b81f-cdc5bf45423b

  Arduino IoT Cloud Variables description

  The following variables are automatically generated and updated when changes are made to the Thing

  bool book_state_1;
  bool book_state_2;
  bool book_state_3;
  bool book_state_4;
  bool book_state_5;

  Variables which are marked as READ/WRITE in the Cloud Thing will also have functions
  which are called when their values are changed from the Dashboard.
  These functions are generated with the Thing and added at the end of this sketch.
*/

#include "thingProperties.h"

typedef enum {
  borrow_out,
  onshelf,
} book_status_bool;

book_status_bool book_state_1_temp;
book_status_bool book_state_2_temp;
book_status_bool book_state_3_temp;
book_status_bool book_state_4_temp;
book_status_bool book_state_5_temp;

HUSKYLENS huskylens;
SoftwareSerial mySerial(17, 16);  // RX, TX
//HUSKYLENS green line >> Pin 17; blue line >> Pin 16

void printResult(HUSKYLENSResult result);

int32_t result_ID_temp;
int debounce_cnt;

void setup() {
  // Initialize serial and wait for port to open:
  Serial.begin(9600);
  // This delay gives the chance to wait for a Serial Monitor without blocking if none is found
  delay(1500);

  // Defined in thingProperties.h
  initProperties();

  // Connect to Arduino IoT Cloud
  ArduinoCloud.begin(ArduinoIoTPreferredConnection);

  all_book_state_print();

  /*
     The following function allows you to obtain more information
     related to the state of network and IoT Cloud connection and errors
     the higher number the more granular information you’ll get.
     The default is 0 (only errors).
     Maximum is 4
  */
  setDebugMessageLevel(2);
  ArduinoCloud.printDebugInfo();



  mySerial.begin(9600);
  while (!huskylens.begin(mySerial))
  {
    Serial.println(F("Begin failed!"));
    Serial.println(F("1.Please recheck the \"Protocol Type\" in HUSKYLENS (General Settings>>Protocol Type>>Serial 9600)"));
    Serial.println(F("2.Please recheck the connection."));
    delay(100);
  }
}

void loop() {
  ArduinoCloud.update();
  // Your code here
  if (!huskylens.request()) Serial.println(F("Fail to request data from HUSKYLENS, recheck the connection!"));
  else if (!huskylens.isLearned()) Serial.println(F("Nothing learned, press learn button on HUSKYLENS to learn one!"));
  else if (!huskylens.available()) Serial.println(F("No block or arrow appears on the screen!"));
  else {
    //Serial.println(F("###########"));
    while (huskylens.available()) {
      HUSKYLENSResult result = huskylens.read();
      printResult(result);
    }
  }
}



/*
  Since BookState1 is READ_WRITE variable, onBookState1Change() is
  executed every time a new value is received from IoT Cloud.
*/
void onBookState1Change() {
  // Add your code here to act upon BookState1 change

}

/*
  Since BookState2 is READ_WRITE variable, onBookState2Change() is
  executed every time a new value is received from IoT Cloud.
*/
void onBookState2Change() {
  // Add your code here to act upon BookState2 change

}

/*
  Since BookState3 is READ_WRITE variable, onBookState3Change() is
  executed every time a new value is received from IoT Cloud.
*/
void onBookState3Change() {
  // Add your code here to act upon BookState3 change

}

/*
  Since BookState4 is READ_WRITE variable, onBookState4Change() is
  executed every time a new value is received from IoT Cloud.
*/
void onBookState4Change() {
  // Add your code here to act upon BookState4 change

}

/*
  Since BookState5 is READ_WRITE variable, onBookState5Change() is
  executed every time a new value is received from IoT Cloud.
*/
void onBookState5Change() {
  // Add your code here to act upon BookState5 change

}

void all_book_state_print() {
  Serial.print("book_state_1 = ");
  Serial.println(book_state_1);
  Serial.print("book_state_2 = ");
  Serial.println(book_state_2);
  Serial.print("book_state_3 = ");
  Serial.println(book_state_3);
  Serial.print("book_state_4 = ");
  Serial.println(book_state_4);
  Serial.print("book_state_5 = ");
  Serial.println(book_state_5);
}

void printResult(HUSKYLENSResult result) {
  if (result.command == COMMAND_RETURN_BLOCK) {
    //Serial.println(String() + F("Block:xCenter=") + result.xCenter + F(",yCenter=") + result.yCenter + F(",width=") + result.width + F(",height=") + result.height + F(",ID=") + result.ID);
    if (result.ID != 0)
    {
      if (result_ID_temp == result.ID)
      {
        if (debounce_cnt > 10)
        {
          switch (result_ID_temp)
          {
            case 1:
            book_state_1 = 1;
            return;
            case 2:
            book_state_2 = 1;
            return;
            case 3:
            book_state_3 = 1;
            return;
            case 4:
            book_state_4 = 1;
            return;
            case 5:
            book_state_5 = 1;
            return;
              }
          all_book_state_print();
        }
        else
        {
          debounce_cnt++;
        }

      }
      else
      {
        debounce_cnt = 0;
      }
      result_ID_temp = result.ID;
    }

  }
  else {
    Serial.println("Object unknown!");
  }
}